BasicPermission (Java Card API, Connected Edition)
Date: 2009-12-11

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.security
Class BasicPermission

    java.lang.Object
      java.security.Permission
          java.security.BasicPermission

Direct Known Subclasses:
  CryptoServicePermission, JCRuntimePermission, NamedPermission, TaskRegistryPermission

    @TransactionType(value=NOT_SUPPORTED)
    public abstract class BasicPermission

extends Permission

The BasicPermission class extends the Permission class, and can be used as the base class for permissions that want to follow the same naming convention as BasicPermission.

The name for a BasicPermission is the name of the given permission (for example, "credentialManager.set", "thread.create" etc). The naming convention follows the hierarchical property naming convention. An asterisk may appear by itself, or if immediately preceded by a "." may appear at the end of the name, to signify a wildcard match. For example, "*" and "java.*" are valid, while "*java", "a*b", and "java*" are not valid.

The action string (inherited from Permission) is unused. Thus, BasicPermission is commonly used as the base class for "named" permissions (ones that contain a name but no actions list; you either have the named permission or you don't.) Subclasses may implement actions on top of BasicPermission, if desired.

This Java Card class is a subset of the CDC 1.1 BasicPermission class. Some interfaces, methods and/or variables have been pruned, and/or other methods simplified, in an effort to reduce the size of this class and/or eliminate dependencies on unsupported features.

Since:
  CDC 1.0, Java Card 3.0
See Also:
  `Permission`, `JCRuntimePermission`, `NamedPermission`, `AccessController`, `AccessControlException`

Constructor Summary
`BasicPermission(String name)` Creates a new BasicPermission with the specified name.
`BasicPermission(String name, String actions)` Creates a new BasicPermission object with the specified name.

Method Summary
`boolean` | `equals(Object obj)` Checks two BasicPermission objects for equality.
`String` | `getActions()` Returns the canonical string representation of the actions, which currently is the empty string "", since there are no actions for a BasicPermission.
`int` | `hashCode()` Returns the hash code value for this object.
`boolean` | `implies(Permission p)` Checks if the specified permission is "implied" by this object.

Methods inherited from class java.security.Permission
`getName, toString`

Methods inherited from class java.lang.Object
`getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### BasicPermission

    public BasicPermission(String name)

  Creates a new BasicPermission with the specified name. Name is the symbolic name of the permission, such as "credentialManager.set", "thread.create", etc.

  Parameters:
    `name` - the name of the BasicPermission.
  Throws:
    `NullPointerException` - if `name` is `null`.
    `IllegalArgumentException` - if `name` is empty.
    `SecurityException` - if `name` is not accessible in the caller's context.

### BasicPermission

    public BasicPermission(String name,
                           String actions)

  Creates a new BasicPermission object with the specified name. The name is the symbolic name of the BasicPermission, and the actions String is currently unused.

  Parameters:
    `name` - the name of the BasicPermission.
    `actions` - ignored.
  Throws:
    `NullPointerException` - if `name` is `null`.
    `IllegalArgumentException` - if `name` is empty.
    `SecurityException` - if `name` is not accessible in the caller's context.

Method Detail

### implies

    public boolean implies(Permission p)

  Checks if the specified permission is "implied" by this object.

  More specifically, this method returns true if:

  - p's class is the same as this object's class, and

  - p's name equals or (in the case of wildcards) is implied by this object's name. For example, "a.b.*" implies "a.b.c".

  Specified by:
    `implies` in class `Permission`
  Parameters:
    `p` - the permission to check against.
  Returns:
    true if the passed permission is equal to or implied by this permission, false otherwise.

### equals

    public boolean equals(Object obj)

  Checks two BasicPermission objects for equality. Checks that obj's class is the same as this object's class and has the same name as this object.

  Specified by:
    `equals` in class `Permission`
  Parameters:
    `obj` - the object we are testing for equality with this object.
  Returns:
    true if obj's class is the same as this object's class and has the same name as this BasicPermission object, false otherwise.
  See Also:
    `Boolean.hashCode()`, `Hashtable`

### hashCode

    public int hashCode()

  Returns the hash code value for this object. The hash code used is the hash code of the name, that is, `getName().hashCode()`, where `getName` is from the Permission superclass.

  Specified by:
    `hashCode` in class `Permission`
  Returns:
    a hash code value for this object.
  See Also:
    `Object.equals(java.lang.Object)`, `Hashtable`

### getActions

    public String getActions()

  Returns the canonical string representation of the actions, which currently is the empty string "", since there are no actions for a BasicPermission.

  Specified by:
    `getActions` in class `Permission`
  Returns:
    the empty string "".

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2009 Sun Microsystems, Inc. All rights reserved.